<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData); //parse chuoi Json thanh object
  console.log(gObjectCountryData);
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

  //gán hàm xử lý sự kiện cho sự kiện change của select car
  $("#car-select").on("change", function () {
    onCarSelectChange(this);
  });
  //gán hàm xử lý sự kiện cho sự kiện change của select country
  $("#country-select").on("change", function () {
    onCountrySelectChange(this);
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm thực hiện sự kiện tải trang
  function onPageLoading() {
    loadDataToCarSelect();
    loadDataToCountrySelect();
  }

  //hàm xử lý sự kiên khi nút send click
  function onBtnSendClick() {
    //khai báo đối tượng chứa dữ liệu
    var vFormDataObj = {
      brandId: "",
      brandName: "",
      typeId: "",
      typeName: "",
      countryId: "",
      countryName: "",
      regionId: "",
      regionName: "",
    };
    //B1: thu thap du lieu
    getFormData(vFormDataObj);
    //B2: validate
    //B3: Front-end
    showDataToConsole(vFormDataObj);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }

  // hàm dùng để load dữ liệu vào select country
  function loadDataToCountrySelect() {
    "use strict";
    var vCountrySelect = $("#country-select");
    for (let bI = 0; bI < gObjectCountryData.length; bII++) {
      var bCountryOption = $("<option/>", {
        value: gObjectCountryData[bI].countryId,
        text: gObjectCountryData[bI].countryName,
      }).appendTo(vCountrySelect);
    }
  }

  // hàm xử lý sự kiện select Country change
  function onCountrySelectChange(paramSelectCountry) {
    //B1: thu thập dữ liệu
    var vCountryId = $(paramSelectCountry).val();
    console.log("countryId: " + vCountryId);
    //B2: validate data
    //B3: Front-end
    loadDataToRegionTypeSelectByCountryId(vCountryId);
  }

  //hàm load dữ liệu vào select car type dựa vào car brandId
  function loadDataToRegionTypeSelectByCountryId(paramCountryId) {
    "use strict";
    var vRegionTypeData = getRegionTypesByCountryId(paramCountryId);
      var vEleSelectRegion = $("#region-type-select");
      // xóa trắng region type select
      vEleSelectRegion.html("");
      // nếu mảng region type không có phần tử nào thì disable region type select
      if (vRegionTypesData.length == 0) {
        vEleSelectRegion.prop("disabled", true);
      }
      else {
        vEleSelectRegion.prop("disabled", false);
        // add options to types of select element
        for (var bI = 0; bI < vRegionTypeData.length; bI++) {
          var bCountryOption = $("<option/>", {
            value: vRegionTypeData[bI].regionId,
            text: vRegionTypeData[bI].regionName,
          }).appendTo(vEleSelectRegion);
        }
      }
  }
   /**
   * get regionTypes by countryId
   * input: countryId of a country
   * output: regionTypes and regionId of found country. If not found, it returns null
   */
   function getRegionTypesByCountryId(paramCountryId) {
    var vRegionFound = false;
    var vRegionTypesResult = null;
    var vIterator = 0;
    while (!vRegionFound && vIterator < gObjectCountryData.length) {
      if (gObjectCountryData[vIterator].countryId === paramCountryId) {
        vRegionFound = true;
        vRegionTypesResult = gObjectCarData[vIterator].regionTypes;
      }
      else {
        vIterator++;
      }
    }
    return vRegionTypesResult;
  }

  //hàm thu thập dữ liệu đầu vào
  function getFormData(paramFormObj) {
    paramFormObj.brandId = $("#car-select").val();
    paramFormObj.brandName = $("#car-select option:selected" ).text();
    paramFormObj.typeId = $("#car-type-select").val();
    paramFormObj.brandName = $("#car-type-select option:selected" ).text();

    paramFormObj.brandId = $("#country-select").val();
    paramFormObj.brandName = $("#country-select option:selected" ).text();
    paramFormObj.typeId = $("#region-type-select").val();
    paramFormObj.brandName = $("#region-type-select option:selected" ).text();
  }

  //hàm hiển thị dữ liệu vào console
  function showDataToConsole(paramFormObj) {
    console.log(paramFormObj);
    console.log("countryId: " + paramFormObj.countryId);
    console.log("countryName: " + paramFormObj.countryName);
    console.log("regionId: " + paramFormObj.regionId);
    console.log("RegionName: " + paramFormObj.regionName);
  }
</script>

</html>